package pl.kielce.tu;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import javax.xml.XMLConstants;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.File;
import java.io.IOException;

public class XMLReader {
    private final File xmlFile;

    public XMLReader(String fileName) {
        xmlFile = new File(fileName);
    }

    public void printXMLFile() {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        try {
            factory.setFeature(XMLConstants.FEATURE_SECURE_PROCESSING,true);
            DocumentBuilder documentBuilder = factory.newDocumentBuilder();
            Document document = documentBuilder.parse(xmlFile);
            parseXMLDocument(document);
        } catch(ParserConfigurationException | SAXException | IOException e) {
            e.printStackTrace();
        }

    }

    private void parseXMLDocument(Document document) {
        NodeList list = document.getElementsByTagName("book");
        for(int i=0; i< list.getLength(); i++) {
            Node node = list.item(i);
            if(node.getNodeType() == Node.ELEMENT_NODE) {
                Element element = (Element) node;
                System.out.println("Gatunek: "+element.getAttribute("genre"));
                System.out.println("Autor: " + element.getElementsByTagName("author").item(0).getTextContent());
                System.out.println("Tytuł: " + element.getElementsByTagName("title").item(0).getTextContent());
                System.out.println("Wydawca: " + element.getElementsByTagName("publisher").item(0).getTextContent());
                System.out.println("Rok wydania: " + element.getElementsByTagName("year").item(0).getTextContent());
            }
        }
    }

}
